
-- table лͷл 
table.toCstring = function(t,exclude)     
   assert(t)
--   if t == nil then return "" end -- Err("table.toCstring input table is nil")
   local mark={}  
   local assign={}
   local function ser_table(tbl,parent)  
	   mark[tbl]=parent     
	   local tmp={}  
	   for k,v in pairs(tbl) do  
		if k ~= exclude and v~="" then
			local key= type(k)=="number" and "'"..k.."'" or "'"..k.."'"       
			if type(v)=="table" then
			elseif type(v) == "string" then  
			 table.insert(tmp, key.."=".. "'"..v.."'")
			elseif type(v) == "number" or type(v) == "boolean" then  
			 table.insert(tmp, key.."='".. tostring(v).."'")  
			end  
		end
	   end  
	   return table.concat(tmp,",")
	end

	local ret = ser_table(t,"")
	return ret
end

-- ΰ汾Կַ0
table.toCstringFilter = function(t,exclude)  
	--if not ASSERT(t) then return end
   assert(t)
--   if t == nil then Err("table.toCstring input table is nil") return "" end
   local mark={}  
   local assign={}
   local function ser_table(tbl,parent)  
	   mark[tbl]=parent     
	   local tmp={}  
	   for k,v in pairs(tbl) do  
		if k ~= exclude then
			local key= type(k)=="number" and "'"..k.."'" or "'"..k.."'"       
			if type(v)=="table" then			
				print("table.toCstring, trying convert a table:"..k)
			elseif type(v) == "string" and v~="" then  
			 table.insert(tmp, key.."=".. "'"..v.."'")  
			elseif (type(v) == "number" and v~=0) or type(v) == "boolean" then  
			 table.insert(tmp, key.."='".. tostring(v).."'")  
			end  
		end
	   end  
	   return table.concat(tmp,",")
	end
	return ser_table(t,"")
end

table.tostring = function(t)
    assert(t)
	local mark={}  
	local assign={}  
	local function ser_table(tbl,parent)  
		mark[tbl]=parent  
		local tmp={}  
		for k,v in pairs(tbl) do  
			local key= type(k)=="number" and "["..k.."]" or "[".. string.format("%q", k) .."]"  
			if type(v)=="table" then  
				local dotkey= parent.. key  
				if mark[v] then  
					table.insert(assign,dotkey.."="..mark[v] .."")  
				else  
					table.insert(tmp, key.."="..ser_table(v,dotkey))  
				end  
			elseif type(v) == "string" then  
				table.insert(tmp, key.."=".. string.format('%q', v))  
			elseif type(v) == "number" or type(v) == "boolean" then  
				table.insert(tmp, key.."=".. tostring(v))  
			end  
		end  
		return "{"..table.concat(tmp,",").."}"  		
	end
	
	local ret = ser_table(t,"ret")..table.concat(assign," ")
	return ret
end  
  
table.loadstring = function(strData)
	if not strData or strData=="" or strData==" " then return nil end
	--sp("loadstring")
	strData = "do local ret="..strData.." return ret end" 
	local f = loadstring(strData)  
	if not f then return {} end
	local ret = f()
	--ep("loadstring")
	return ret
	--if f then return f() end  
end

--function dostring(strData)
--	local f = loadstring(strData)
--	if f then f()
--	else return false end
--	return true
--end
-------------------------------------------------------
-- :ַָ,ַָ
-- :Ӵ.(пմ)
function string.split(str, split_char)
    local sub_str_tab = {};
    while (true) do
        local pos = string.find(str, split_char);
        if (not pos) then
            sub_str_tab[#sub_str_tab + 1] = str;
            break;
        end
        local sub_str = string.sub(str, 1, pos - 1);
        sub_str_tab[#sub_str_tab + 1] = sub_str;
        str = string.sub(str, pos + 1, #str);
    end

    return sub_str_tab;
end

-- @param str
-- @return number
function utfstrlen(str)
	local len = #str;
	local left = len;
	local cnt = 0;
	local arr={0,0xc0,0xe0,0xf0,0xf8,0xfc};
	while left ~= 0 do
		local tmp=string.byte(str,-left);
		local i=#arr;
		while arr[i] do
			if tmp>=arr[i] then left=left-i;break;end
			i=i-1;
		end
		cnt=cnt+1;
	end
	return cnt;
end